// -*-C++-*-
/*!
 * @file  com_frm_ctrlSVC_impl.cpp
 * @brief Service implementation code of com_frm_ctrl.idl
 *
 */

#include "com_frm_ctrlSVC_impl.h"

/*
 * Example implementational code for IDL interface ComFrmCtrl
 */
ComFrmCtrlSVC_impl::ComFrmCtrlSVC_impl()
{
  // Please add extra constructor code here.
}


ComFrmCtrlSVC_impl::~ComFrmCtrlSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
void ComFrmCtrlSVC_impl::set_param(CORBA::Double k_pv, CORBA::Double v_m, CORBA::Double k_pr)
{
  k_gain = k_pv;
  v_max = v_m;
  k_pos_rot = k_pr;
}
//
// method for internal use
//

int ComFrmCtrlSVC_impl::calc_vel(FRAME geo_ref, FRAME geo_cur, 
				VECTOR p_vel, VECTOR r_vel) {
  VECTOR dir, axis;
  MATRIX r_mat;
  REAL t_diff, p_diff, r_diff;
  REAL phase;
  REAL lim;
  REAL v_cmd,vp, vr;
  int i;

  lim = v_max / k_gain;
  v_sub(geo_ref.vtr,geo_cur.vtr,dir);
  p_diff = sqrt(v_dot(dir,dir));
  if(p_diff > settle*0.1) {
    sv_mul((1.0/p_diff),dir,dir);
  } else {
    for(i=0;i<3;i++) dir[i] = 0.0;
  }
  m_trans(geo_cur.mtr,r_mat);
  m_mul(r_mat,geo_ref.mtr,r_mat);
  r_diff = rot_axis(r_mat,axis);     // axis in geo_cur
  mv_mul(geo_cur.mtr,axis,axis);
  t_diff = sqrt(p_diff*p_diff + k_pos_rot * k_pos_rot * r_diff * r_diff);
  if(t_diff>=lim) {
    v_cmd = v_max;
  } else {
    v_cmd = k_gain * t_diff;
  }
  if(t_diff > settle) {
    state = 0;
    vp = v_cmd * p_diff/t_diff;
    vr = v_cmd * r_diff/t_diff;
  } else {
    state = 1;
    vp=0.0;
    vr=0.0;
  }
  for(i=0;i<3;i++) {
    p_vel[i] = vp * dir[i];
    r_vel[i] = vr * axis[i];
  }
  return 0;
}


// End of example implementational code



