#!/usr/bin/env python

# Python example implementations generated from my_service.idl

import CORBA, PortableServer

# Import the Python stub modules so type definitions are available.

import _GlobalIDL

# Import the Python Skeleton modules so skeleton base classes are available.

import _GlobalIDL__POA


# Implementation of interface Mine::MyService

class ComMixer_i (_GlobalIDL__POA.ComMixer):

    def __init__(self, comp):
        # Initialise member variables here
        self.weight={}
        self.comp=comp

   # void set_weigth(in string name, in DoubleSeq weight)
    def set_weight(self, name, weight):
        self.weight[name]=weight

    # DoubleSeq get_weigth(in string name)
    def get_weight(self, name):
        if name in self.weight.keys() :
            return self.weight[name]
        else :
            return []

    # StringSeq get_keys()
    def get_keys(self):
            return self.comp.out_buf.keys()

if __name__ == "__main__":
    import sys
    
    # Initialise the ORB
    orb = CORBA.ORB_init(sys.argv)
    
    # As an example, we activate an object in the Root POA
    poa = orb.resolve_initial_references("RootPOA")

    # Create an instance of a servant class
    servant = MyService_i()

    # Activate it in the Root POA
    poa.activate_object(servant)

    # Get the object reference to the object
    objref = servant._this()
    
    # Print a stringified IOR for it
    print orb.object_to_string(objref)

    # Activate the Root POA's manager
    poa._get_the_POAManager().activate()

    # Run the ORB, blocking this thread
    orb.run()

