#!/usr/bin/env python
# -*- Python -*-

import sys
import time
sys.path.append(".")

# Import RTM module
import OpenRTM
import RTC

import slider
import thread

class AHO :
  pass

aho=AHO()


# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="global_idl">

# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
slidercomp_spec = ["implementation_id", "sliderComp", 
		 "type_name",         "sliderComp", 
		 "description",       "generate double seq", 
		 "version",           "1.0", 
		 "vendor",            "Takashi Suehiro, AIST", 
		 "category",          "data_generator", 
		 "activity_type",     "DataFlowComponent", 
		 "max_instance",      "10", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 "conf.default.channels", "[('data', -10, 10, 0.1, 100)]",
		 ""]

# </rtc-template>

class sliderComp(OpenRTM.DataFlowComponentBase):
	def __init__(self, manager):
		OpenRTM.DataFlowComponentBase.__init__(self, manager)

		# DataPorts initialization
		# <rtc-template block="data_ports">
		self._d_out = RTC.TimedDoubleSeq(RTC.Time(0,0),[])
		self._outOut = OpenRTM.OutPort("out", self._d_out, OpenRTM.RingBuffer(8))
		self.registerOutPort("out",self._outOut)

		# </rtc-template>


		# DataPorts initialization
		# <rtc-template block="service_ports">

		# </rtc-template>


		# initialize of configuration-data.
		# <rtc-template block="configurations">
		self._channels = ["[('data', -10, 10, 0.1, 100)]"]

		# </rtc-template>
		self.slider_data=None
		 
	def onInitialize(self):
		# Bind variables and configuration variable
		# <rtc-template block="bind_config">
                self.act_flag = False
		self.bindParameter("channels", self._channels, "[('data', -10, 10, 0.1, 100)]")
                self.chan_old = self._channels[0]
                print self.chan_old
                tmp = eval(self.chan_old)
                self.slider=slider.SliderMulti(tmp)
                print self.slider
                self.slider.set_callbacks(self.cbFunc,self.cbFunc,self.cbFunc)
		# </rtc-template>
		return RTC.RTC_OK


	#def onFinalize(self):
	#	return RTC.RTC_OK

	#def onStartup(self, ec_id):
	#	return RTC.RTC_OK

	#def onShutdown(self, ec_id):
	#	return RTC.RTC_OK

	def onActivated(self, ec_id):
           if(self.chan_old != self._channels[0]) :
                self.chan_old = self._channels[0]
		print self.chan_old
                tmp = eval(self.chan_old)
                print tmp
                print self.slider
                self.slider.destroy()
                print "aho"
                self.slider = slider.SliderMulti(tmp)
                print "baka"
                self.slider.set_callbacks(self.cbFunc,self.cbFunc,self.cbFunc)
                print "par"
		self.slider_data=None
# zero reset
           for chan in self.slider.channels :
                chan.set(0)
           self.slider_data = self.slider.get()
           print self.slider_data
# 
           self.act_flag = True
	   return RTC.RTC_OK

	def onDeactivated(self, ec_id):
                self.act_flag = Fales
		return RTC.RTC_OK

	def onExecute(self, ec_id):
            if self.act_flag :
	        if self.slider_data :
                    self._d_out.data=self.slider_data
                    self._outOut.write()
            time.sleep(0.05)
            return RTC.RTC_OK

	#def onAborting(self, ec_id):
	#	return RTC.RTC_OK

	def onError(self, ec_id):
                self.act_flag = Fales
		return RTC.RTC_OK

	def onReset(self, ec_id):
           self.act_flag = Fales
           return RTC.RTC_OK

	#def onStateUpdate(self, ec_id):
	#	return RTC.RTC_OK

	#def onRateChanged(self, ec_id):
	#	return RTC.RTC_OK

        def cbFunc(self,ee) :
            if self.act_flag :
                self.slider_data = self.slider.get()
                print self.slider_data
#                tmp= self.slider.get()
#                print tmp
#                self._d_out.data=tmp
#                self._outOut.write()

def MyModuleInit(manager):
    profile = OpenRTM.Properties(defaults_str=slidercomp_spec)
    manager.registerFactory(profile,
                            sliderComp,
                            OpenRTM.Delete)

    # Create a component
    comp = manager.createComponent("sliderComp")
    aho.comp=comp

def main():
	mgr = OpenRTM.Manager.init(len(sys.argv), sys.argv)
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager(True)
        aho.comp.slider.mainloop()
#
#        print comp.chan_old
#        tmp = eval(comp.chan_old)
#        print tmp
#        comp.slider=slider.SliderMulti(tmp)
#        print comp.slider.get()

if __name__ == "__main__":
	main()
